package jp.ne.sakura.sabowl.gpsnmeajp.quartzpaydemo;

import android.content.Context;
import android.content.SharedPreferences;
import android.media.AudioAttributes;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

import jp.ne.sakura.sabowl.gpsnmeajp.quartzpaydemo.LazyNfcFHCELite;

public class MainActivity extends AppCompatActivity {

    private TextView mText;
    private String debugMsgTitle = "QuartzPayDemo";

    private AudioAttributes audioAttributes;
    private SoundPool mSoundPool;
    private int Sound_Success;

    private int value = 0;
    private int showvalue = 0;
    SharedPreferences prefer;
    LazyNfcFHCELite hce;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(debugMsgTitle,"Create");
        setContentView(R.layout.activity_main);

        mText = (TextView) findViewById(R.id.valueText);
        hce = new LazyNfcFHCELite(this,"jp.ne.sakura.sabowl.gpsnmeajp.quartzpaydemo","jp.ne.sakura.sabowl.gpsnmeajp.quartzpaydemo.LazyNfcFHCELiteProxy");

        prefer = getPreferences(Context.MODE_PRIVATE);

        //HCEコールバックを設定
        hce.registerCallback(new LazyNfcFHCELite.onHCEFAccessCallback()
        {
            @Override
            public byte[] onRead(int service,int address) {
                //ReadWithoutEncryptionを受信したとき
                Log.d(debugMsgTitle, "onRead: "+String.format("%04X",address));
                //(R/Wに送信する内容をreturnする)
                byte h = (byte)((value>>8)&0xFF);
                byte l = (byte)(value&0xFF);
                return new byte[]{h,l,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
            }

            @Override
            public boolean onWrite(int service,int address, byte[] data) {
                //WriteWithoutEncryptionを受信したとき
                Log.d(debugMsgTitle, "onWrite: "+String.format("%04X",address));

                //R/Wから送られてきたデータを表示
                String debug="";
                for(int i=0;i<data.length;i++)
                {
                    debug += String.format("%02X,",data[i]);
                }
                Log.d(debugMsgTitle,debug);

                int dat = ((data[1]&0xFF)<<8) | (data[2]&0xFF);
                if(data[0]==0x00)
                {
                    value += dat;
                }
                if(data[0]==0x01)
                {
                    value -= dat;
                }
                SharedPreferences.Editor editor = prefer.edit();
                editor.putInt("int", value);
                editor.apply();

                final Handler handler = new Handler();
                final Runnable r = new Runnable() {
                    int count = 0;
                    @Override
                    public void run() {
                        // UIスレッド
                        if(value > (showvalue))
                        {
                            showvalue += (value-showvalue)/10;
                        }else if(value < (showvalue))
                        {
                            showvalue -= (showvalue-value)/10;
                        }
                        if((showvalue-value)/10 == 0)
                        {
                            showvalue = value;
                            mText.setText(""+showvalue);
                            return;
                        }

                        mText.setText(""+showvalue);
                        handler.postDelayed(this, 1);
                    }
                };
                handler.post(r);

                mSoundPool.play(Sound_Success,1.0F, 1.0F, 0, 0, 1.0F);
                //R/Wに送信成功応答を返す
                return true;
            }

            @Override
            public void onDeactivate(int reason) {
                //通信が切断されたとき
                Log.d(debugMsgTitle, "onDeactivate: "+reason);
            }
        });

        //オーディオシステム準備
        audioAttributes = new AudioAttributes.Builder().setUsage(AudioAttributes.USAGE_GAME).setContentType(AudioAttributes.CONTENT_TYPE_SPEECH).build();
        setVolumeControlStream(AudioManager.STREAM_MUSIC);
    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.d(debugMsgTitle,"Resume");
        hce.enable();
        //オーディオ環境準備
        mSoundPool = new SoundPool.Builder().setAudioAttributes(audioAttributes).setMaxStreams(3).build();
        //オーディオ読み込み
        Sound_Success = mSoundPool.load(getApplicationContext(), R.raw.ok, 0);

        value = prefer.getInt("int",0);
        showvalue = value;
        mText.setText(""+value);
    }

    @Override
    protected void onPause() {
        super.onPause();
        Log.d(debugMsgTitle,"Pause");
        hce.disable();
        mSoundPool.play(Sound_Success, 1.0F, 1.0F, 0, 0, 1.0F);
        //オーディオ開放
        mSoundPool.release();
    }
}
